/*
        liberis -- A set of libraries for controlling the NEC PC-FX

Copyright (C) 2011              Alex Marshall "trap15" <trap15@raidenii.net>

# This code is licensed to you under the terms of the MIT license;
# see file LICENSE or http://www.opensource.org/licenses/mit-license.php
*/

/*! \file
 * \brief Standard integer types
 */

#ifndef _LIBERIS_TYPES_H_
#define _LIBERIS_TYPES_H_

typedef unsigned int		uint32_t;  /*!< Unsigned 32bit integer */
typedef unsigned short		uint16_t;  /*!< Unsigned 16bit integer */
typedef unsigned char		uint8_t;   /*!< Unsigned 8bit integer */
typedef signed int		int32_t;   /*!< Signed 32bit integer */
typedef signed short		int16_t;   /*!< Signed 16bit integer */
typedef signed char		int8_t;    /*!< Signed 8bit integer */
typedef volatile uint32_t	vuint32_t; /*!< Volatile unsigned 32bit integer */
typedef volatile uint16_t	vuint16_t; /*!< Volatile unsigned 16bit integer */
typedef volatile uint8_t	vuint8_t;  /*!< Volatile unsigned 8bit integer */
typedef volatile int32_t	vint32_t;  /*!< Volatile signed 32bit integer */
typedef volatile int16_t	vint16_t;  /*!< Volatile signed 16bit integer */
typedef volatile int8_t		vint8_t;   /*!< Volatile signed 8bit integer */

typedef uint32_t	u32;  /*!< Unsigned 32bit integer */
typedef uint16_t	u16;  /*!< Unsigned 16bit integer */
typedef uint8_t		u8;   /*!< Unsigned 8bit integer */
typedef int32_t		s32;  /*!< Signed 32bit integer */
typedef int16_t		s16;  /*!< Signed 16bit integer */
typedef int8_t		s8;   /*!< Signed 8bit integer */
typedef vuint32_t	vu32; /*!< Volatile unsigned 32bit integer */
typedef vuint16_t	vu16; /*!< Volatile unsigned 16bit integer */
typedef vuint8_t	vu8;  /*!< Volatile unsigned 8bit integer */
typedef vint32_t	vs32; /*!< Volatile signed 32bit integer */
typedef vint16_t	vs16; /*!< Volatile signed 16bit integer */
typedef vint8_t		vs8;  /*!< Volatile signed 8bit integer */

#endif

